
_Init_Empty_Deck:

;Cards.mbas,75 :: 		sub procedure Init_Empty_Deck(dim PtrDeck as ^Deck)
;Cards.mbas,80 :: 		PtrDeck^.Cards[CARD_COUNT] = 0                        ' Since the [0] index is the count, just set that count to 0.  Deck is empty
	MOVFF       FARG_Init_Empty_Deck_PtrDeck+0, FSR1L+0
	MOVFF       FARG_Init_Empty_Deck_PtrDeck+1, FSR1H+0
	CLRF        POSTINC1+0 
;Cards.mbas,81 :: 		end sub
L_end_Init_Empty_Deck:
	RETURN      0
; end of _Init_Empty_Deck

_Init_Empty_Hand:

;Cards.mbas,83 :: 		sub procedure Init_Empty_Hand(dim PtrHand as ^Hand)
;Cards.mbas,88 :: 		PtrHand^.Cards[CARD_COUNT] = 0                        ' Since the [0] index is the count, just set that count to 0.  Hand is empty
	MOVFF       FARG_Init_Empty_Hand_PtrHand+0, FSR1L+0
	MOVFF       FARG_Init_Empty_Hand_PtrHand+1, FSR1H+0
	CLRF        POSTINC1+0 
;Cards.mbas,89 :: 		end sub
L_end_Init_Empty_Hand:
	RETURN      0
; end of _Init_Empty_Hand

_Init_Full_Deck:

;Cards.mbas,96 :: 		dim i,j,k as byte
;Cards.mbas,98 :: 		PtrDeck^.Cards[CARD_COUNT] = 52                       ' A full deck has 52 cards, so set the count at index 0 to 52
	MOVFF       FARG_Init_Full_Deck_PtrDeck+0, FSR1L+0
	MOVFF       FARG_Init_Full_Deck_PtrDeck+1, FSR1H+0
	MOVLW       52
	MOVWF       POSTINC1+0 
;Cards.mbas,99 :: 		for i = 1 to 13                                       ' Let's loop through 13 cards, Ace through King or 1 through 13
	MOVLW       1
	MOVWF       Init_Full_Deck_i+0 
L__Init_Full_Deck4:
;Cards.mbas,100 :: 		k = 1
	MOVLW       1
	MOVWF       Init_Full_Deck_k+0 
;Cards.mbas,101 :: 		for j = 4*i-3 to 4*i                                ' Let's loop through 4 suits, but incrementing by 4 each time
	MOVF        Init_Full_Deck_i+0, 0 
	MOVWF       Init_Full_Deck_j+0 
	RLCF        Init_Full_Deck_j+0, 1 
	BCF         Init_Full_Deck_j+0, 0 
	RLCF        Init_Full_Deck_j+0, 1 
	BCF         Init_Full_Deck_j+0, 0 
	MOVLW       3
	SUBWF       Init_Full_Deck_j+0, 1 
L__Init_Full_Deck8:
	MOVF        Init_Full_Deck_i+0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        Init_Full_Deck_j+0, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Init_Full_Deck12
;Cards.mbas,102 :: 		PtrDeck^.Cards[j]=i*10+k                          ' The card is the value * 10 + suit.  We just reverse this to get suit and value from a card
	MOVF        Init_Full_Deck_j+0, 0 
	ADDWF       FARG_Init_Full_Deck_PtrDeck+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Init_Full_Deck_PtrDeck+1, 0 
	MOVWF       FSR1L+1 
	MOVLW       10
	MULWF       Init_Full_Deck_i+0 
	MOVF        PRODL+0, 0 
	MOVWF       R0 
	MOVF        Init_Full_Deck_k+0, 0 
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,103 :: 		k = k + 1
	INCF        Init_Full_Deck_k+0, 1 
;Cards.mbas,104 :: 		next j
	MOVF        Init_Full_Deck_j+0, 0 
	XORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Init_Full_Deck12
	INCF        Init_Full_Deck_j+0, 1 
	GOTO        L__Init_Full_Deck8
L__Init_Full_Deck12:
;Cards.mbas,105 :: 		next i
	MOVF        Init_Full_Deck_i+0, 0 
	XORLW       13
	BTFSC       STATUS+0, 2 
	GOTO        L__Init_Full_Deck7
	INCF        Init_Full_Deck_i+0, 1 
	GOTO        L__Init_Full_Deck4
L__Init_Full_Deck7:
;Cards.mbas,106 :: 		end sub
L_end_Init_Full_Deck:
	RETURN      0
; end of _Init_Full_Deck

_Retrieve_Card_Value:

;Cards.mbas,108 :: 		sub function  Retrieve_Card_Value(dim Card as byte) as byte
;Cards.mbas,114 :: 		result = Card div 10                                  ' The tens and hundreds place hold the value, so just divide by 10
	MOVLW       10
	MOVWF       R4 
	MOVF        FARG_Retrieve_Card_Value_Card+0, 0 
	MOVWF       R0 
	CALL        _Div_8x8_U+0, 0
	MOVF        R0, 0 
	MOVWF       Retrieve_Card_Value_local_result+0 
;Cards.mbas,115 :: 		end sub
	MOVF        Retrieve_Card_Value_local_result+0, 0 
	MOVWF       R0 
L_end_Retrieve_Card_Value:
	RETURN      0
; end of _Retrieve_Card_Value

_Retrieve_Card_Suit:

;Cards.mbas,117 :: 		sub function  Retrieve_Card_Suit(dim Card as byte) as byte
;Cards.mbas,123 :: 		result = (Card mod 4) + 1                           ' Since 1-4 represents the suit, get rid of everything else.
	MOVLW       3
	ANDWF       FARG_Retrieve_Card_Suit_Card+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDLW       1
	MOVWF       R1 
;Cards.mbas,124 :: 		end sub
	MOVF        R1, 0 
	MOVWF       R0 
L_end_Retrieve_Card_Suit:
	RETURN      0
; end of _Retrieve_Card_Suit

_Card_To_Text:

;Cards.mbas,129 :: 		dim RetVal as string[4]
	MOVF        R0, 0 
	MOVWF       Card_To_Text_local_result+0 
	MOVF        R1, 0 
	MOVWF       Card_To_Text_local_result+1 
;Cards.mbas,131 :: 		select case Retrieve_Card_Value(Card)                 ' First get the card value
	MOVF        FARG_Card_To_Text_Card+0, 0 
	MOVWF       FARG_Retrieve_Card_Value_Card+0 
	CALL        _Retrieve_Card_Value+0, 0
;Cards.mbas,132 :: 		case 1                                              ' Call an Ace an Ace
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text19
;Cards.mbas,133 :: 		RetVal = "A"                                      ' 1 = Ace
	MOVLW       65
	MOVWF       Card_To_Text_RetVal+0 
	CLRF        Card_To_Text_RetVal+1 
	GOTO        L__Card_To_Text16
L__Card_To_Text19:
;Cards.mbas,134 :: 		case 11
	MOVF        R0, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text22
;Cards.mbas,135 :: 		RetVal = "J"                                      ' 11 = Jack
	MOVLW       74
	MOVWF       Card_To_Text_RetVal+0 
	CLRF        Card_To_Text_RetVal+1 
	GOTO        L__Card_To_Text16
L__Card_To_Text22:
;Cards.mbas,136 :: 		case 12
	MOVF        R0, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text25
;Cards.mbas,137 :: 		RetVal = "Q"                                      ' 12 = Queen
	MOVLW       81
	MOVWF       Card_To_Text_RetVal+0 
	CLRF        Card_To_Text_RetVal+1 
	GOTO        L__Card_To_Text16
L__Card_To_Text25:
;Cards.mbas,138 :: 		case 13
	MOVF        R0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text28
;Cards.mbas,139 :: 		RetVal = "K"                                      ' 13 = King
	MOVLW       75
	MOVWF       Card_To_Text_RetVal+0 
	CLRF        Card_To_Text_RetVal+1 
	GOTO        L__Card_To_Text16
L__Card_To_Text28:
;Cards.mbas,141 :: 		ByteToStr(Retrieve_Card_Value(Card),RetVal)       ' For everything else, do a simply byte to text conversion
	MOVF        FARG_Card_To_Text_Card+0, 0 
	MOVWF       FARG_Retrieve_Card_Value_Card+0 
	CALL        _Retrieve_Card_Value+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_ByteToStr_input+0 
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FARG_ByteToStr_output+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FARG_ByteToStr_output+1 
	CALL        _ByteToStr+0, 0
L__Card_To_Text16:
;Cards.mbas,143 :: 		ltrim(RetVal)                                         ' Trim the result
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FARG_ltrim_astring+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FARG_ltrim_astring+1 
	CALL        _ltrim+0, 0
;Cards.mbas,144 :: 		select case Retrieve_Card_Suit(Card)                  ' Second, get the card suit
	MOVF        FARG_Card_To_Text_Card+0, 0 
	MOVWF       FARG_Retrieve_Card_Suit_Card+0 
	CALL        _Retrieve_Card_Suit+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__Card_To_Text+0 
	MOVF        FLOC__Card_To_Text+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text32
;Cards.mbas,146 :: 		RetVal = RetVal + "C"                             ' 1 = Clubs
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FSR1L+1 
	CALL        ___FZinS+0, 0
	MOVLW       67
	MOVWF       POSTINC1+0 
	CLRF        POSTINC1+0 
	GOTO        L__Card_To_Text29
L__Card_To_Text32:
;Cards.mbas,147 :: 		case 2
	MOVF        FLOC__Card_To_Text+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text35
;Cards.mbas,148 :: 		RetVal = RetVal + "D"                             ' 2 = Diamonds
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FSR1L+1 
	CALL        ___FZinS+0, 0
	MOVLW       68
	MOVWF       POSTINC1+0 
	CLRF        POSTINC1+0 
	GOTO        L__Card_To_Text29
L__Card_To_Text35:
;Cards.mbas,149 :: 		case 3
	MOVF        FLOC__Card_To_Text+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text38
;Cards.mbas,150 :: 		RetVal = RetVal + "H"                             ' 3 = Hearts
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FSR1L+1 
	CALL        ___FZinS+0, 0
	MOVLW       72
	MOVWF       POSTINC1+0 
	CLRF        POSTINC1+0 
	GOTO        L__Card_To_Text29
L__Card_To_Text38:
;Cards.mbas,151 :: 		case 4
	MOVF        FLOC__Card_To_Text+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__Card_To_Text41
;Cards.mbas,152 :: 		RetVal = RetVal + "S"                             ' 4 = Spades
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FSR1L+1 
	CALL        ___FZinS+0, 0
	MOVLW       83
	MOVWF       POSTINC1+0 
	CLRF        POSTINC1+0 
	GOTO        L__Card_To_Text29
L__Card_To_Text41:
L__Card_To_Text29:
;Cards.mbas,154 :: 		RESULT = RetVal                                       ' Return the result such as 3S or JH or 1D for display
	MOVF        Card_To_Text_local_result+0, 0 
	MOVWF       FSR1L+0 
	MOVF        Card_To_Text_local_result+1, 0 
	MOVWF       FSR1L+1 
	MOVLW       Card_To_Text_RetVal+0
	MOVWF       FSR2L+0 
	MOVLW       hi_addr(Card_To_Text_RetVal+0)
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	CLRF        POSTINC1+0 
;Cards.mbas,155 :: 		end sub
L_end_Card_To_Text:
	RETURN      0
; end of _Card_To_Text

_Get_Card_From_Deck:

;Cards.mbas,165 :: 		dim i as byte
;Cards.mbas,167 :: 		RESULT = PtrDeck^.Cards[index]                        ' Set the result to the card in the deck at the index provided
	MOVF        FARG_Get_Card_From_Deck_index+0, 0 
	ADDWF       FARG_Get_Card_From_Deck_PtrDeck+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_Get_Card_From_Deck_PtrDeck+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
;Cards.mbas,168 :: 		for i = index + 1 to PtrDeck^.Cards[CARD_COUNT]       ' Take all the cards after the index card
	MOVF        FARG_Get_Card_From_Deck_index+0, 0 
	ADDLW       1
	MOVWF       R3 
L__Get_Card_From_Deck43:
	MOVFF       FARG_Get_Card_From_Deck_PtrDeck+0, FSR0L+0
	MOVFF       FARG_Get_Card_From_Deck_PtrDeck+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R3, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Get_Card_From_Deck47
;Cards.mbas,169 :: 		PtrDeck^.Cards[i - 1] = PtrDeck^.Cards[i]           ' And move them one slot down
	DECF        R3, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDWF       FARG_Get_Card_From_Deck_PtrDeck+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Get_Card_From_Deck_PtrDeck+1, 0 
	MOVWF       FSR1L+1 
	MOVF        R3, 0 
	ADDWF       FARG_Get_Card_From_Deck_PtrDeck+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_Get_Card_From_Deck_PtrDeck+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,170 :: 		next i
	MOVF        R3, 0 
	XORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Get_Card_From_Deck47
	INCF        R3, 1 
	GOTO        L__Get_Card_From_Deck43
L__Get_Card_From_Deck47:
;Cards.mbas,171 :: 		PtrDeck^.Cards[CARD_COUNT] = PtrDeck^.Cards[CARD_COUNT] - 1   ' Lower the card count of the deck by 1
	MOVFF       FARG_Get_Card_From_Deck_PtrDeck+0, FSR0L+0
	MOVFF       FARG_Get_Card_From_Deck_PtrDeck+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       FARG_Get_Card_From_Deck_PtrDeck+0, FSR1L+0
	MOVFF       FARG_Get_Card_From_Deck_PtrDeck+1, FSR1H+0
	DECF        R0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,172 :: 		end sub
	MOVF        R2, 0 
	MOVWF       R0 
L_end_Get_Card_From_Deck:
	RETURN      0
; end of _Get_Card_From_Deck

_Get_Top_Card_From_Deck:

;Cards.mbas,174 :: 		sub function  Get_Top_Card_From_Deck(dim PtrDeck as ^Deck) as byte
;Cards.mbas,180 :: 		RESULT = Get_Card_From_Deck(PtrDeck, PtrDeck^.Cards[CARD_COUNT])      ' Call Get_Card_From_Deck with the deck card count as the index
	MOVF        FARG_Get_Top_Card_From_Deck_PtrDeck+0, 0 
	MOVWF       FARG_Get_Card_From_Deck_PtrDeck+0 
	MOVF        FARG_Get_Top_Card_From_Deck_PtrDeck+1, 0 
	MOVWF       FARG_Get_Card_From_Deck_PtrDeck+1 
	MOVFF       FARG_Get_Top_Card_From_Deck_PtrDeck+0, FSR0L+0
	MOVFF       FARG_Get_Top_Card_From_Deck_PtrDeck+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Get_Card_From_Deck_index+0 
	CALL        _Get_Card_From_Deck+0, 0
	MOVF        R0, 0 
	MOVWF       Get_Top_Card_From_Deck_local_result+0 
;Cards.mbas,181 :: 		end sub
	MOVF        Get_Top_Card_From_Deck_local_result+0, 0 
	MOVWF       R0 
L_end_Get_Top_Card_From_Deck:
	RETURN      0
; end of _Get_Top_Card_From_Deck

_Get_Card_From_Hand:

;Cards.mbas,191 :: 		dim i as byte
;Cards.mbas,193 :: 		RESULT = PtrHand^.Cards[index]                   ' Set the result to the card in the hand at the index provided
	MOVF        FARG_Get_Card_From_Hand_index+0, 0 
	ADDWF       FARG_Get_Card_From_Hand_PtrHand+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_Get_Card_From_Hand_PtrHand+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
;Cards.mbas,194 :: 		for i = index + 1 to PtrHand^.Cards[CARD_COUNT]  ' Take all the cards after the index
	MOVF        FARG_Get_Card_From_Hand_index+0, 0 
	ADDLW       1
	MOVWF       R3 
L__Get_Card_From_Hand50:
	MOVFF       FARG_Get_Card_From_Hand_PtrHand+0, FSR0L+0
	MOVFF       FARG_Get_Card_From_Hand_PtrHand+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R3, 0 
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Get_Card_From_Hand54
;Cards.mbas,195 :: 		PtrHand^.Cards[i - 1] = PtrHand^.Cards[i]      ' And move them one slot down
	DECF        R3, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDWF       FARG_Get_Card_From_Hand_PtrHand+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Get_Card_From_Hand_PtrHand+1, 0 
	MOVWF       FSR1L+1 
	MOVF        R3, 0 
	ADDWF       FARG_Get_Card_From_Hand_PtrHand+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_Get_Card_From_Hand_PtrHand+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,196 :: 		next i
	MOVF        R3, 0 
	XORWF       R1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Get_Card_From_Hand54
	INCF        R3, 1 
	GOTO        L__Get_Card_From_Hand50
L__Get_Card_From_Hand54:
;Cards.mbas,197 :: 		PtrHand^.Cards[CARD_COUNT] = PtrHand^.Cards[CARD_COUNT] - 1   ' Lower the card count of the hand by 1
	MOVFF       FARG_Get_Card_From_Hand_PtrHand+0, FSR0L+0
	MOVFF       FARG_Get_Card_From_Hand_PtrHand+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       FARG_Get_Card_From_Hand_PtrHand+0, FSR1L+0
	MOVFF       FARG_Get_Card_From_Hand_PtrHand+1, FSR1H+0
	DECF        R0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,198 :: 		end sub
	MOVF        R2, 0 
	MOVWF       R0 
L_end_Get_Card_From_Hand:
	RETURN      0
; end of _Get_Card_From_Hand

_Get_Top_Card_From_Hand:

;Cards.mbas,200 :: 		sub function  Get_Top_Card_From_Hand(dim PtrHand as ^Hand) as byte
;Cards.mbas,206 :: 		RESULT = Get_Card_From_Hand(PtrHand, PtrHand^.Cards[CARD_COUNT])     ' Call Get_Card_From_Hand with the hand card count as the index
	MOVF        FARG_Get_Top_Card_From_Hand_PtrHand+0, 0 
	MOVWF       FARG_Get_Card_From_Hand_PtrHand+0 
	MOVF        FARG_Get_Top_Card_From_Hand_PtrHand+1, 0 
	MOVWF       FARG_Get_Card_From_Hand_PtrHand+1 
	MOVFF       FARG_Get_Top_Card_From_Hand_PtrHand+0, FSR0L+0
	MOVFF       FARG_Get_Top_Card_From_Hand_PtrHand+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Get_Card_From_Hand_index+0 
	CALL        _Get_Card_From_Hand+0, 0
	MOVF        R0, 0 
	MOVWF       Get_Top_Card_From_Hand_local_result+0 
;Cards.mbas,207 :: 		end sub
	MOVF        Get_Top_Card_From_Hand_local_result+0, 0 
	MOVWF       R0 
L_end_Get_Top_Card_From_Hand:
	RETURN      0
; end of _Get_Top_Card_From_Hand

_Add_Card_To_Deck:

;Cards.mbas,209 :: 		sub procedure Add_Card_To_Deck(dim PtrDeck as ^Deck, dim Card as byte)
;Cards.mbas,215 :: 		PtrDeck^.Cards[CARD_COUNT] = PtrDeck^.Cards[CARD_COUNT] + 1   ' Increment the card count of the deck
	MOVFF       FARG_Add_Card_To_Deck_PtrDeck+0, FSR0L+0
	MOVFF       FARG_Add_Card_To_Deck_PtrDeck+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       FARG_Add_Card_To_Deck_PtrDeck+0, FSR1L+0
	MOVFF       FARG_Add_Card_To_Deck_PtrDeck+1, FSR1H+0
	MOVF        R0, 0 
	ADDLW       1
	MOVWF       POSTINC1+0 
;Cards.mbas,216 :: 		PtrDeck^.Cards[PtrDeck^.Cards[CARD_COUNT]] = Card             ' Put the new card in the last position or top of deck
	MOVFF       FARG_Add_Card_To_Deck_PtrDeck+0, FSR0L+0
	MOVFF       FARG_Add_Card_To_Deck_PtrDeck+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDWF       FARG_Add_Card_To_Deck_PtrDeck+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Add_Card_To_Deck_PtrDeck+1, 0 
	MOVWF       FSR1L+1 
	MOVF        FARG_Add_Card_To_Deck_Card+0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,217 :: 		end sub
L_end_Add_Card_To_Deck:
	RETURN      0
; end of _Add_Card_To_Deck

_Add_Card_To_Hand:

;Cards.mbas,219 :: 		sub procedure Add_Card_To_Hand(dim PtrHand as ^Hand, dim Card as byte)
;Cards.mbas,224 :: 		PtrHand^.Cards[CARD_COUNT] = PtrHand^.Cards[CARD_COUNT] + 1   ' Increment the card count of the hand
	MOVFF       FARG_Add_Card_To_Hand_PtrHand+0, FSR0L+0
	MOVFF       FARG_Add_Card_To_Hand_PtrHand+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       FARG_Add_Card_To_Hand_PtrHand+0, FSR1L+0
	MOVFF       FARG_Add_Card_To_Hand_PtrHand+1, FSR1H+0
	MOVF        R0, 0 
	ADDLW       1
	MOVWF       POSTINC1+0 
;Cards.mbas,225 :: 		PtrHand^.Cards[PtrHand^.Cards[CARD_COUNT]] = Card             ' Put the card in the last position or top of the hand
	MOVFF       FARG_Add_Card_To_Hand_PtrHand+0, FSR0L+0
	MOVFF       FARG_Add_Card_To_Hand_PtrHand+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDWF       FARG_Add_Card_To_Hand_PtrHand+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Add_Card_To_Hand_PtrHand+1, 0 
	MOVWF       FSR1L+1 
	MOVF        FARG_Add_Card_To_Hand_Card+0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,226 :: 		end sub
L_end_Add_Card_To_Hand:
	RETURN      0
; end of _Add_Card_To_Hand

_Transfer_Deck_To_Deck:

;Cards.mbas,235 :: 		dim i as byte
;Cards.mbas,237 :: 		for i = PtrSource^.Cards[CARD_COUNT] to 1 step -1                     ' Step through every card in the Source deck from the top of the deck
	MOVFF       FARG_Transfer_Deck_To_Deck_PtrSource+0, FSR0L+0
	MOVFF       FARG_Transfer_Deck_To_Deck_PtrSource+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       Transfer_Deck_To_Deck_i+0 
	MOVLW       1
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Transfer_Deck_To_Deck63
L__Transfer_Deck_To_Deck60:
;Cards.mbas,238 :: 		Add_Card_To_Deck(PtrTarget, Get_Card_From_Deck(PtrSource,i))        ' Place the card on the Target deck
	MOVF        FARG_Transfer_Deck_To_Deck_PtrSource+0, 0 
	MOVWF       FARG_Get_Card_From_Deck_PtrDeck+0 
	MOVF        FARG_Transfer_Deck_To_Deck_PtrSource+1, 0 
	MOVWF       FARG_Get_Card_From_Deck_PtrDeck+1 
	MOVF        Transfer_Deck_To_Deck_i+0, 0 
	MOVWF       FARG_Get_Card_From_Deck_index+0 
	CALL        _Get_Card_From_Deck+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Add_Card_To_Deck_Card+0 
	MOVF        FARG_Transfer_Deck_To_Deck_PtrTarget+0, 0 
	MOVWF       FARG_Add_Card_To_Deck_PtrDeck+0 
	MOVF        FARG_Transfer_Deck_To_Deck_PtrTarget+1, 0 
	MOVWF       FARG_Add_Card_To_Deck_PtrDeck+1 
	CALL        _Add_Card_To_Deck+0, 0
;Cards.mbas,239 :: 		next i
	MOVF        Transfer_Deck_To_Deck_i+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Transfer_Deck_To_Deck63
	MOVLW       255
	ADDWF       Transfer_Deck_To_Deck_i+0, 1 
	GOTO        L__Transfer_Deck_To_Deck60
L__Transfer_Deck_To_Deck63:
;Cards.mbas,240 :: 		end sub
L_end_Transfer_Deck_To_Deck:
	RETURN      0
; end of _Transfer_Deck_To_Deck

_Transfer_Hand_To_Deck:

;Cards.mbas,249 :: 		dim i as byte
;Cards.mbas,251 :: 		for i = PtrSource^.Cards[CARD_COUNT] to 1 step -1                     ' Step through every card in the hand from the top of the hand
	MOVFF       FARG_Transfer_Hand_To_Deck_PtrSource+0, FSR0L+0
	MOVFF       FARG_Transfer_Hand_To_Deck_PtrSource+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       Transfer_Hand_To_Deck_i+0 
	MOVLW       1
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Transfer_Hand_To_Deck69
L__Transfer_Hand_To_Deck66:
;Cards.mbas,252 :: 		Add_Card_To_Deck(PtrTarget, Get_Card_From_Hand(PtrSource,i))        ' Place the card on the Target Deck
	MOVF        FARG_Transfer_Hand_To_Deck_PtrSource+0, 0 
	MOVWF       FARG_Get_Card_From_Hand_PtrHand+0 
	MOVF        FARG_Transfer_Hand_To_Deck_PtrSource+1, 0 
	MOVWF       FARG_Get_Card_From_Hand_PtrHand+1 
	MOVF        Transfer_Hand_To_Deck_i+0, 0 
	MOVWF       FARG_Get_Card_From_Hand_index+0 
	CALL        _Get_Card_From_Hand+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Add_Card_To_Deck_Card+0 
	MOVF        FARG_Transfer_Hand_To_Deck_PtrTarget+0, 0 
	MOVWF       FARG_Add_Card_To_Deck_PtrDeck+0 
	MOVF        FARG_Transfer_Hand_To_Deck_PtrTarget+1, 0 
	MOVWF       FARG_Add_Card_To_Deck_PtrDeck+1 
	CALL        _Add_Card_To_Deck+0, 0
;Cards.mbas,253 :: 		next i
	MOVF        Transfer_Hand_To_Deck_i+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Transfer_Hand_To_Deck69
	MOVLW       255
	ADDWF       Transfer_Hand_To_Deck_i+0, 1 
	GOTO        L__Transfer_Hand_To_Deck66
L__Transfer_Hand_To_Deck69:
;Cards.mbas,254 :: 		end sub
L_end_Transfer_Hand_To_Deck:
	RETURN      0
; end of _Transfer_Hand_To_Deck

_Shuffle_Deck:

;Cards.mbas,263 :: 		dim i, c1, c2, c3 as byte
;Cards.mbas,266 :: 		for i = 1 to 3
	MOVLW       1
	MOVWF       Shuffle_Deck_i+0 
L__Shuffle_Deck72:
;Cards.mbas,267 :: 		for c1 = PtrDeck^.Cards[CARD_COUNT] to 2 STEP -1    ' Run down the cards
	MOVFF       FARG_Shuffle_Deck_PtrDeck+0, FSR0L+0
	MOVFF       FARG_Shuffle_Deck_PtrDeck+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       Shuffle_Deck_c1+0 
	MOVLW       2
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Shuffle_Deck80
L__Shuffle_Deck77:
;Cards.mbas,268 :: 		c2 = (rand() mod c1) + 1                          ' Pick a random card number from 1 to c1
	CALL        _rand+0, 0
	MOVF        Shuffle_Deck_c1+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	INCF        R0, 1 
;Cards.mbas,269 :: 		c3 = PtrDeck^.Cards[c2]                           ' Put the random card in c3
	MOVF        R0, 0 
	ADDWF       FARG_Shuffle_Deck_PtrDeck+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_Shuffle_Deck_PtrDeck+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Shuffle_Deck_c3+0 
;Cards.mbas,270 :: 		PtrDeck^.Cards[c2] = PtrDeck^.Cards[c1]           ' Put c1 into the random card's position
	MOVF        R0, 0 
	ADDWF       FARG_Shuffle_Deck_PtrDeck+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Shuffle_Deck_PtrDeck+1, 0 
	MOVWF       FSR1L+1 
	MOVF        Shuffle_Deck_c1+0, 0 
	ADDWF       FARG_Shuffle_Deck_PtrDeck+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_Shuffle_Deck_PtrDeck+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,271 :: 		PtrDeck^.Cards[c1] = c3                           ' Put the random card into c1
	MOVF        Shuffle_Deck_c1+0, 0 
	ADDWF       FARG_Shuffle_Deck_PtrDeck+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_Shuffle_Deck_PtrDeck+1, 0 
	MOVWF       FSR1L+1 
	MOVF        Shuffle_Deck_c3+0, 0 
	MOVWF       POSTINC1+0 
;Cards.mbas,272 :: 		next c1
	MOVF        Shuffle_Deck_c1+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L__Shuffle_Deck80
	MOVLW       255
	ADDWF       Shuffle_Deck_c1+0, 1 
	GOTO        L__Shuffle_Deck77
L__Shuffle_Deck80:
;Cards.mbas,273 :: 		next i
	MOVF        Shuffle_Deck_i+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L__Shuffle_Deck75
	INCF        Shuffle_Deck_i+0, 1 
	GOTO        L__Shuffle_Deck72
L__Shuffle_Deck75:
;Cards.mbas,274 :: 		end sub
L_end_Shuffle_Deck:
	RETURN      0
; end of _Shuffle_Deck
