
_ClearLCD:

;Output.mbas,90 :: 		sub procedure ClearLCD()
;Output.mbas,95 :: 		ANSELB = 0                                            ' port B is output
	CLRF        ANSELB+0 
;Output.mbas,96 :: 		rowIsTop = True                                       ' We start on top row
	MOVLW       255
	MOVWF       Output_rowIsTop+0 
;Output.mbas,97 :: 		screenIsBlank = True                                  ' We start with blank screen
	MOVLW       255
	MOVWF       Output_screenIsBlank+0 
;Output.mbas,98 :: 		Lcd_Init()                                            ' Initialize Lcd module
	CALL        _Lcd_Init+0, 0
;Output.mbas,99 :: 		Lcd_Cmd(_LCD_CLEAR)                                   ' Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Output.mbas,100 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)                              ' Cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Output.mbas,101 :: 		end sub
L_end_ClearLCD:
	RETURN      0
; end of _ClearLCD

_PrintLCD:

;Output.mbas,103 :: 		sub procedure PrintLCD(DIM byref Text as string[16])
;Output.mbas,111 :: 		IF screenIsBlank THEN                 ' If the screen is blank
	MOVF        Output_screenIsBlank+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__PrintLCD3
;Output.mbas,112 :: 		Lcd_Out(1,1,Text)                   ' Write to the first line of the screen
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        FARG_PrintLCD_Text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        FARG_PrintLCD_Text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Output.mbas,113 :: 		screenIsBlank = FALSE               ' Screen is no longer blank
	CLRF        Output_screenIsBlank+0 
	GOTO        L__PrintLCD4
;Output.mbas,114 :: 		ELSE
L__PrintLCD3:
;Output.mbas,115 :: 		IF rowIsTop THEN                    ' If we have only written to the top row
	MOVF        Output_rowIsTop+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__PrintLCD6
;Output.mbas,116 :: 		Lcd_Out(2,1,Text)                ' Then write to the bottom row
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        FARG_PrintLCD_Text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        FARG_PrintLCD_Text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Output.mbas,117 :: 		rowIsTop = FALSE                 ' We have now written to a row other than top
	CLRF        Output_rowIsTop+0 
;Output.mbas,118 :: 		row2Text = Text                  ' Save this bottom row text for scrolling purposes
	MOVLW       Output_row2Text+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Output_row2Text+0)
	MOVWF       FSR1L+1 
	MOVF        FARG_PrintLCD_Text+0, 0 
	MOVWF       FSR2L+0 
	MOVF        FARG_PrintLCD_Text+1, 0 
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	CLRF        POSTINC1+0 
	GOTO        L__PrintLCD7
;Output.mbas,119 :: 		ELSE                                ' Otherwise, we have already written top and bottom row
L__PrintLCD6:
;Output.mbas,120 :: 		Lcd_Cmd(_LCD_CLEAR)              ' Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Output.mbas,121 :: 		Lcd_Out(1,1,row2Text)            ' Write the prior bottom row text to the top row
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       Output_row2Text+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(Output_row2Text+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Output.mbas,122 :: 		Lcd_Out(2,1,Text)                ' Wrote the new text to the bottom row
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        FARG_PrintLCD_Text+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        FARG_PrintLCD_Text+1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Output.mbas,123 :: 		row2Text = Text                  ' Save this bottom row text for scrolling purposes
	MOVLW       Output_row2Text+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Output_row2Text+0)
	MOVWF       FSR1L+1 
	MOVF        FARG_PrintLCD_Text+0, 0 
	MOVWF       FSR2L+0 
	MOVF        FARG_PrintLCD_Text+1, 0 
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	CLRF        POSTINC1+0 
;Output.mbas,124 :: 		END IF
L__PrintLCD7:
;Output.mbas,125 :: 		END IF
L__PrintLCD4:
;Output.mbas,126 :: 		end sub
L_end_PrintLCD:
	RETURN      0
; end of _PrintLCD

_interrupt:

;Output.mbas,128 :: 		sub procedure interrupt
;Output.mbas,135 :: 		LATA = 0                              ' turn off all 7seg displays
	CLRF        LATA+0 
;Output.mbas,136 :: 		LATD = portd_array[portd_index]       ' bring appropriate value to PORTD
	MOVLW       Output_portd_array+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(Output_portd_array+0)
	MOVWF       FSR0L+1 
	MOVF        Output_portd_index+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       LATD+0 
;Output.mbas,137 :: 		LATA = shifter                        ' turn on appropriate 7seg. display
	MOVF        Output_shifter+0, 0 
	MOVWF       LATA+0 
;Output.mbas,141 :: 		shifter= shifter << 1
	MOVF        Output_shifter+0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       Output_shifter+0 
;Output.mbas,142 :: 		if (shifter > 8) then
	MOVF        R1, 0 
	SUBLW       8
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt10
;Output.mbas,143 :: 		shifter = 1
	MOVLW       1
	MOVWF       Output_shifter+0 
L__interrupt10:
;Output.mbas,147 :: 		Inc(portd_index)                      ' increment to the next digit of interest, usually a 1-4 digit number
	INCF        Output_portd_index+0, 1 
;Output.mbas,148 :: 		if (portd_index > 3) then             ' roll back to the first digit
	MOVF        Output_portd_index+0, 0 
	SUBLW       3
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt13
;Output.mbas,149 :: 		portd_index = 0                     ' back to the beginning
	CLRF        Output_portd_index+0 
L__interrupt13:
;Output.mbas,151 :: 		TMR0L = 0                             ' reset TIMER0 value
	CLRF        TMR0L+0 
;Output.mbas,152 :: 		TMR0IF_bit = 0                        ' Clear TMR0IF
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;Output.mbas,153 :: 		end sub
L_end_interrupt:
L__interrupt68:
	RETFIE      1
; end of _interrupt

Output_mask:

;Output.mbas,155 :: 		sub function mask(dim num as word) as word
;Output.mbas,164 :: 		case 0
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask70
	MOVLW       0
	XORWF       FARG_mask_num+0, 0 
L_Output_mask70:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask19
;Output.mbas,165 :: 		result= $3F         ' 0011 1111
	MOVLW       63
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask19:
;Output.mbas,166 :: 		case 1
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask71
	MOVLW       1
	XORWF       FARG_mask_num+0, 0 
L_Output_mask71:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask22
;Output.mbas,167 :: 		result= $06         ' 0000 0110
	MOVLW       6
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask22:
;Output.mbas,168 :: 		case 2
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask72
	MOVLW       2
	XORWF       FARG_mask_num+0, 0 
L_Output_mask72:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask25
;Output.mbas,169 :: 		result= $5B         ' 0101 1011
	MOVLW       91
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask25:
;Output.mbas,170 :: 		case 3
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask73
	MOVLW       3
	XORWF       FARG_mask_num+0, 0 
L_Output_mask73:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask28
;Output.mbas,171 :: 		result= $4F         ' 0100 1111
	MOVLW       79
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask28:
;Output.mbas,172 :: 		case 4
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask74
	MOVLW       4
	XORWF       FARG_mask_num+0, 0 
L_Output_mask74:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask31
;Output.mbas,173 :: 		result= $66         ' 0110 0110
	MOVLW       102
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask31:
;Output.mbas,174 :: 		case 5
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask75
	MOVLW       5
	XORWF       FARG_mask_num+0, 0 
L_Output_mask75:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask34
;Output.mbas,175 :: 		result= $6D         ' 0110 1101
	MOVLW       109
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask34:
;Output.mbas,176 :: 		case 6
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask76
	MOVLW       6
	XORWF       FARG_mask_num+0, 0 
L_Output_mask76:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask37
;Output.mbas,177 :: 		result= $7D         ' 0111 1101
	MOVLW       125
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask37:
;Output.mbas,178 :: 		case 7
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask77
	MOVLW       7
	XORWF       FARG_mask_num+0, 0 
L_Output_mask77:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask40
;Output.mbas,179 :: 		result= $07         ' 0000 0111
	MOVLW       7
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask40:
;Output.mbas,180 :: 		case 8
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask78
	MOVLW       8
	XORWF       FARG_mask_num+0, 0 
L_Output_mask78:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask43
;Output.mbas,181 :: 		result= $7F         ' 0111 1111
	MOVLW       127
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask43:
;Output.mbas,182 :: 		case 9
	MOVLW       0
	XORWF       FARG_mask_num+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask79
	MOVLW       9
	XORWF       FARG_mask_num+0, 0 
L_Output_mask79:
	BTFSS       STATUS+0, 2 
	GOTO        L_Output_mask46
;Output.mbas,183 :: 		result= $6F         ' 0110 1111
	MOVLW       111
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	GOTO        L_Output_mask16
L_Output_mask46:
L_Output_mask16:
;Output.mbas,185 :: 		end sub
	MOVF        R2, 0 
	MOVWF       R0 
	MOVF        R3, 0 
	MOVWF       R1 
L_end_mask:
	RETURN      0
; end of Output_mask

_Print7_off:

;Output.mbas,187 :: 		sub procedure Print7_off()
;Output.mbas,190 :: 		LATA = 0                          ' turn off all 7seg displays
	CLRF        LATA+0 
;Output.mbas,191 :: 		GIE_bit = 0                       ' turn off interrupts
	BCF         GIE_bit+0, BitPos(GIE_bit+0) 
;Output.mbas,192 :: 		TMR0IE_bit = 0
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;Output.mbas,193 :: 		end sub
L_end_Print7_off:
	RETURN      0
; end of _Print7_off

_Print7:

;Output.mbas,195 :: 		sub procedure Print7(DIM Number as Word)
;Output.mbas,197 :: 		ANSELA = 0          ' Configure PORTA pins as digital
	CLRF        ANSELA+0 
;Output.mbas,198 :: 		ANSELD = 0          ' Configure PORTD pins as digital
	CLRF        ANSELD+0 
;Output.mbas,199 :: 		TRISA = 0           ' Configure PORTA as output
	CLRF        TRISA+0 
;Output.mbas,200 :: 		LATA = 0            ' Clear PORTA
	CLRF        LATA+0 
;Output.mbas,201 :: 		TRISD = 0           ' Configure PORTD as output
	CLRF        TRISD+0 
;Output.mbas,202 :: 		LATD = 0            ' Clear PORTD
	CLRF        LATD+0 
;Output.mbas,203 :: 		T0CON = 0xC4        ' Set TMR0 in 8bit mode, assign prescaler to TMR0
	MOVLW       196
	MOVWF       T0CON+0 
;Output.mbas,204 :: 		TMR0L = 0           ' clear TMROL
	CLRF        TMR0L+0 
;Output.mbas,206 :: 		portd_index = 0     ' Initialize the port index for the 7 segment display
	CLRF        Output_portd_index+0 
;Output.mbas,207 :: 		shifter = 1         ' Initialize the shifter
	MOVLW       1
	MOVWF       Output_shifter+0 
;Output.mbas,208 :: 		GIE_bit = 1         ' Interrupts enabled
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;Output.mbas,209 :: 		TMR0IE_bit = 1      ' Timer interrupt enabled
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;Output.mbas,211 :: 		digit = number / 1000               ' extract thousands digit
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	MOVF        FARG_Print7_Number+0, 0 
	MOVWF       R0 
	MOVF        FARG_Print7_Number+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       Output_digit+0 
	MOVF        R1, 0 
	MOVWF       Output_digit+1 
;Output.mbas,212 :: 		portd_array[3] = mask(digit)        ' and store it to PORTD array
	MOVF        R0, 0 
	MOVWF       FARG_mask_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_mask_num+1 
	CALL        Output_mask+0, 0
	MOVF        R0, 0 
	MOVWF       Output_portd_array+3 
;Output.mbas,213 :: 		digit = (number / 100) mod 10       ' extract hundreds digit
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_Print7_Number+0, 0 
	MOVWF       R0 
	MOVF        FARG_Print7_Number+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       Output_digit+0 
	MOVF        R1, 0 
	MOVWF       Output_digit+1 
;Output.mbas,214 :: 		portd_array[2] = mask(digit)        ' and store it to PORTD array
	MOVF        R0, 0 
	MOVWF       FARG_mask_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_mask_num+1 
	CALL        Output_mask+0, 0
	MOVF        R0, 0 
	MOVWF       Output_portd_array+2 
;Output.mbas,215 :: 		digit = (number / 10) mod 10        ' extract tens digit
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_Print7_Number+0, 0 
	MOVWF       R0 
	MOVF        FARG_Print7_Number+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       Output_digit+0 
	MOVF        R1, 0 
	MOVWF       Output_digit+1 
;Output.mbas,216 :: 		portd_array[1] = mask(digit)        ' and store it to PORTD array
	MOVF        R0, 0 
	MOVWF       FARG_mask_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_mask_num+1 
	CALL        Output_mask+0, 0
	MOVF        R0, 0 
	MOVWF       Output_portd_array+1 
;Output.mbas,217 :: 		digit = number mod 10               ' extract ones digit
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_Print7_Number+0, 0 
	MOVWF       R0 
	MOVF        FARG_Print7_Number+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       Output_digit+0 
	MOVF        R1, 0 
	MOVWF       Output_digit+1 
;Output.mbas,218 :: 		portd_array[0] = mask(digit)        ' and store it to PORTD array
	MOVF        R0, 0 
	MOVWF       FARG_mask_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_mask_num+1 
	CALL        Output_mask+0, 0
	MOVF        R0, 0 
	MOVWF       Output_portd_array+0 
;Output.mbas,220 :: 		end sub
L_end_Print7:
	RETURN      0
; end of _Print7

_ClearGLCD:

;Output.mbas,223 :: 		SUB PROCEDURE ClearGLCD()
;Output.mbas,227 :: 		ANSELB = 0         ' Configure PORTB pins as digital
	CLRF        ANSELB+0 
;Output.mbas,228 :: 		ANSELD = 0         ' Configure PORTD pins as digital
	CLRF        ANSELD+0 
;Output.mbas,229 :: 		page = 0           ' Configure PAGE to be top row
	CLRF        Output_page+0 
;Output.mbas,231 :: 		Glcd_Init()        ' Initialize Glcd
	CALL        _Glcd_Init+0, 0
;Output.mbas,232 :: 		Glcd_Fill(0xFF)    ' Clear Glcd
	MOVLW       255
	MOVWF       FARG_Glcd_Fill_pattern+0 
	CALL        _Glcd_Fill+0, 0
;Output.mbas,233 :: 		Glcd_Set_Font(@System3x5, 3, 5, 32)         ' Change font
	MOVLW       _System3x5+0
	MOVWF       FARG_Glcd_Set_Font_ActiveFont+0 
	MOVLW       hi_addr(_System3x5+0)
	MOVWF       FARG_Glcd_Set_Font_ActiveFont+1 
	MOVLW       higher_addr(_System3x5+0)
	MOVWF       FARG_Glcd_Set_Font_ActiveFont+2 
	MOVLW       3
	MOVWF       FARG_Glcd_Set_Font_FontWidth+0 
	MOVLW       5
	MOVWF       FARG_Glcd_Set_Font_FontHeight+0 
	MOVLW       32
	MOVWF       FARG_Glcd_Set_Font_FontOffs+0 
	CALL        _Glcd_Set_Font+0, 0
;Output.mbas,235 :: 		END SUB
L_end_ClearGLCD:
	RETURN      0
; end of _ClearGLCD

_PrintGLCD:

;Output.mbas,242 :: 		DIM i as byte
;Output.mbas,244 :: 		IF (page = 0) THEN
	MOVF        Output_page+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__PrintGLCD52
;Output.mbas,245 :: 		Glcd_Init()                                 ' Initialize Glcd
	CALL        _Glcd_Init+0, 0
;Output.mbas,246 :: 		Glcd_Fill(0xFF)                             ' Clear Glcd
	MOVLW       255
	MOVWF       FARG_Glcd_Fill_pattern+0 
	CALL        _Glcd_Fill+0, 0
;Output.mbas,247 :: 		Glcd_Set_Font(@System3x5, 3, 5, 32)         ' Change font  - this might be a good place to save some ROM, by replacing font library
	MOVLW       _System3x5+0
	MOVWF       FARG_Glcd_Set_Font_ActiveFont+0 
	MOVLW       hi_addr(_System3x5+0)
	MOVWF       FARG_Glcd_Set_Font_ActiveFont+1 
	MOVLW       higher_addr(_System3x5+0)
	MOVWF       FARG_Glcd_Set_Font_ActiveFont+2 
	MOVLW       3
	MOVWF       FARG_Glcd_Set_Font_FontWidth+0 
	MOVLW       5
	MOVWF       FARG_Glcd_Set_Font_FontHeight+0 
	MOVLW       32
	MOVWF       FARG_Glcd_Set_Font_FontOffs+0 
	CALL        _Glcd_Set_Font+0, 0
L__PrintGLCD52:
;Output.mbas,250 :: 		IF (page = 8) THEN                            ' If we are at the bottom of the page
	MOVF        Output_page+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L__PrintGLCD55
;Output.mbas,251 :: 		Glcd_Fill(0xFF)                             ' Clear Glcd
	MOVLW       255
	MOVWF       FARG_Glcd_Fill_pattern+0 
	CALL        _Glcd_Fill+0, 0
;Output.mbas,252 :: 		Glcd_Write_Text(page_text[0], 0, 0, 1)      ' Time to write our buffered screen starting at the first row from buffer
	MOVLW       Output_page_text+0
	MOVWF       FARG_Glcd_Write_Text_text+0 
	MOVLW       hi_addr(Output_page_text+0)
	MOVWF       FARG_Glcd_Write_Text_text+1 
	CLRF        FARG_Glcd_Write_Text_x_pos+0 
	CLRF        FARG_Glcd_Write_Text_page_num+0 
	MOVLW       1
	MOVWF       FARG_Glcd_Write_Text_color+0 
	CALL        _Glcd_Write_Text+0, 0
;Output.mbas,253 :: 		FOR i = 1 to 6
	MOVLW       1
	MOVWF       PrintGLCD_i+0 
L__PrintGLCD58:
;Output.mbas,254 :: 		Glcd_Write_Text(page_text[i], 0, i, 1)    ' Write the rest of the rows from puffer
	MOVLW       33
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        PrintGLCD_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Output_page_text+0
	ADDWF       R0, 0 
	MOVWF       FARG_Glcd_Write_Text_text+0 
	MOVLW       hi_addr(Output_page_text+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_Glcd_Write_Text_text+1 
	CLRF        FARG_Glcd_Write_Text_x_pos+0 
	MOVF        PrintGLCD_i+0, 0 
	MOVWF       FARG_Glcd_Write_Text_page_num+0 
	MOVLW       1
	MOVWF       FARG_Glcd_Write_Text_color+0 
	CALL        _Glcd_Write_Text+0, 0
;Output.mbas,255 :: 		page_text[i-1] = page_text[i]             ' Save a new buffer that only contains the top 7 rows since row 1 will move off the top
	DECF        PrintGLCD_i+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       33
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Output_page_text+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Output_page_text+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       33
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        PrintGLCD_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Output_page_text+0
	ADDWF       R0, 0 
	MOVWF       FSR2L+0 
	MOVLW       hi_addr(Output_page_text+0)
	ADDWFC      R1, 0 
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	CLRF        POSTINC1+0 
;Output.mbas,256 :: 		NEXT i
	MOVF        PrintGLCD_i+0, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L__PrintGLCD61
	INCF        PrintGLCD_i+0, 1 
	GOTO        L__PrintGLCD58
L__PrintGLCD61:
;Output.mbas,257 :: 		page = 7                                    ' set the line to the last row of the display
	MOVLW       7
	MOVWF       Output_page+0 
L__PrintGLCD55:
;Output.mbas,260 :: 		Glcd_Write_Text(text, 0, page, 1)             ' Write the new line of text
	MOVF        FARG_PrintGLCD_Text+0, 0 
	MOVWF       FARG_Glcd_Write_Text_text+0 
	MOVF        FARG_PrintGLCD_Text+1, 0 
	MOVWF       FARG_Glcd_Write_Text_text+1 
	CLRF        FARG_Glcd_Write_Text_x_pos+0 
	MOVF        Output_page+0, 0 
	MOVWF       FARG_Glcd_Write_Text_page_num+0 
	MOVLW       1
	MOVWF       FARG_Glcd_Write_Text_color+0 
	CALL        _Glcd_Write_Text+0, 0
;Output.mbas,261 :: 		if page > 0 then
	MOVF        Output_page+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__PrintGLCD63
;Output.mbas,262 :: 		page_text[page-1] = text                    ' Save it to the page_text
	DECF        Output_page+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       33
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       Output_page_text+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(Output_page_text+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        FARG_PrintGLCD_Text+0, 0 
	MOVWF       FSR2L+0 
	MOVF        FARG_PrintGLCD_Text+1, 0 
	MOVWF       FSR2L+1 
	CALL        ___CS2S+0, 0
	CLRF        POSTINC1+0 
L__PrintGLCD63:
;Output.mbas,264 :: 		inc(page)                                     ' Increment the page
	INCF        Output_page+0, 1 
;Output.mbas,266 :: 		end sub
L_end_PrintGLCD:
	RETURN      0
; end of _PrintGLCD
